VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsIEnumShellItems"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Private Const CLSID_EnumShellItems As String = ""
    
Private Const IID_IEnumShellItems As String = _
    "{70629033-e363-4a28-a567-0db78006e6d7}"
    
Dim m_initialized As Boolean
Dim m_Interface As Interface_Data

Private Enum E_vtbOffsets
    vtb_QueryInterface
    vtb_AddRef
    vtb_Release
    vtb_Fetch 'Next
    vtb_Skip
    vtb_Reset
    vtb_Clone
End Enum

Public Function Fetch(ByVal celt As Long, ByRef rgelt As Long, ByRef pceltFetched As Long) As Boolean
    
    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_Fetch, celt, rgelt, pceltFetched) Then

        bRet = True

    End If
    
    Fetch = bRet
    
End Function

Public Function Skip(ByVal celt As Long) As Boolean
    
    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_Skip, celt) Then

        bRet = True

    End If
    
    Skip = bRet
    
End Function

Public Function Reset() As Boolean
    
    Dim bRet As Boolean
    
    If x_OleInvoke(vtb_Reset) Then

        bRet = True

    End If
    
    Reset = bRet
    
End Function

Public Function Clone() As Long
    
    Dim lRet As Long
    Dim ppenum As Long
    Dim pppenum As Long
    
    pppenum = VarPtr(ppenum)
    
    If x_OleInvoke(vtb_Clone, pppenum) Then

        lRet = ppenum

    End If
    
    Clone = lRet
    
End Function

Public Sub RaiseError(Optional ByVal Raise As Boolean = True)
    
    m_Interface.RaiseErrors = Raise
    
End Sub

Public Sub Initialize(Optional ByVal pInterface As Long = 0)

    m_Interface.owner = ObjPtr(Me)
    m_Interface.RaiseErrors = True

    If pInterface = 0 Then

        m_initialized = InitInterface(m_Interface, CLSID_EnumShellItems, _
            IID_IEnumShellItems)
    
    Else
        
        m_Interface.ifc = pInterface
        m_initialized = True
    
    End If
End Sub

Private Sub Class_Terminate()

    ReleaseInterface m_Interface
    
End Sub

Private Function x_OleInvoke(vtb As E_vtbOffsets, ParamArray var()) As _
    Boolean
    
    Dim ret As Long
    
    If Not m_initialized Then
    
        InterfaceError m_Interface, ecd_OleInvoke
        
    Else
    
        x_OleInvoke = oleInvoke(m_Interface, vtb, ret, True, var)
        
    End If
    
End Function

Private Sub x_RaiseError()

    With m_Interface
    
        If .ecd Then Err.Raise ERR_BASE + .ecd, App.EXEName & _
            ".clsIEnumShellItems", .etx
            
        .ecd = 0
        .etx = ""
        
    End With
    
End Sub



