Attribute VB_Name = "modDrives"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Option Explicit

' **************** Kernel32.dll ****************
Private Declare Function GetDriveType Lib "kernel32" _
                         Alias "GetDriveTypeA" ( _
                         ByVal nDrive As String) As Long

Private Declare Function GetLogicalDriveStrings Lib "kernel32" _
                         Alias "GetLogicalDriveStringsA" ( _
                         ByVal nBufferLength As Long, _
                         ByVal lpBuffer As String) As Long

Private Declare Function GetVolumeNameForVolumeMountPoint Lib "kernel32" _
                         Alias "GetVolumeNameForVolumeMountPointA" ( _
                         ByVal lpszVolumeMountPoint As String, _
                         ByVal lpszVolumeName As String, _
                         ByVal cchBufferLength As Long) As Long

' ermittelt die Volume-GUID von einem Laufwerk
Public Function GetVolumeGUID(ByVal sPath As String) As String

    Dim buff As String
    Dim cbbuff As Long

    buff = String$(1024, 0)
    cbbuff = Len(buff)

    sPath = Left$(sPath, 3)

    If GetVolumeNameForVolumeMountPoint(sPath, buff, cbbuff) <> 0 Then
        If InStr(1, buff, Chr$(0)) Then

            buff = Left$(buff, InStr(1, buff, Chr$(0)) - 1)

        End If

        buff = Mid$(buff, InStr(1, buff, "{"))
        buff = Mid$(buff, 1, InStr(1, buff, "}"))

        GetVolumeGUID = buff

    End If

End Function

' ermittelt alle Laufwerke
Public Function GetAllDrives(ByRef Drives() As String) As Long

    Dim sBuffer As String * 255
    Dim sDrives As String
    Dim lResult As Long
    Dim sDrive As String
    Dim sPos As Integer
    Dim lCounter As Long

    lResult = GetLogicalDriveStrings(Len(sBuffer), sBuffer)
    sDrives = Left$(sBuffer, lResult)

    lCounter = 0
    ReDim Drives(lCounter)

    While Len(sDrives) > 0

        sPos = InStr(sDrives, Chr$(0))
        sDrive = Left$(sDrives, sPos - 1)
        sDrives = Mid$(sDrives, sPos + 1)

        ReDim Preserve Drives(lCounter)

        Drives(lCounter) = Left$(sDrive, 3)

        lCounter = lCounter + 1

    Wend

    GetAllDrives = lCounter

End Function


