Attribute VB_Name = "modRecyleBin"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Option Explicit

' **************** Const ****************
Private Const S_OK As Long = &H0
Private Const MAX_PATH As Long = 260&
Private Const CSIDL_BITBUCKET As Long = &HA
Private Const KF_FLAG_DEFAULT As Long = &H0

Private Const IID_IShellItem As String = _
    "{43826d1e-e718-42ee-bc55-a1e261c37bfe}"

Private Const IID_IShellFolder As String = _
    "{000214E6-0000-0000-C000-000000000046}"

Private Const IID_IShellFolder2 As String = _
    "{93f2f68c-1d1b-11d3-a30e-00c04f79abd1}"

Private Const IID_IEnumShellItems As String = _
    "{70629033-e363-4a28-a567-0db78006e6d7}"

Private Const BHID_EnumItems As String = _
    "{94f60519-2850-4924-aa5a-d15e84868039}"

Private Const FOLDERID_RecycleBinFolder As String = _
    "{B7534046-3ECB-4C18-BE4E-64CD4CB7D6AC}"
    
' **************** Enum ****************
Public Enum EmptyFlags
    SHERB_NORMAL = &H0
    SHERB_NOCONFIRMATION = &H1
    SHERB_NOPROGRESSUI = &H2
    SHERB_NOSOUND = &H4
    SHERB_SILENT = SHERB_NOCONFIRMATION Or SHERB_NOPROGRESSUI Or SHERB_NOSOUND
End Enum

' **************** Type ****************
Private Type ULARGE_INTEGER
    'Lo As Long
    'Hi As Long
    LoHi As Currency
End Type

Private Type SHQUERYRBINFO
    cbSize As Long
    i64Size As ULARGE_INTEGER
    i64NumItems As ULARGE_INTEGER
End Type

Private Type RecycleBin
    sPath As String
    sDrive As String
    sDriveGuid As String
    sFolder As String
    sFullPath As String
    cMaxCapacity As Currency
    bNukeOnDelete As Boolean
End Type

' SHELLDETAILS.str
Private Type STRRET
    uType As Long
    cbStr(0 To MAX_PATH - 1) As Byte
End Type

'IShellFolder2.GetDetailsOf
Private Type SHELLDETAILS
    fmt As Long
    cxChar As Long
    str As STRRET
End Type

' **************** Shell32.dll ****************
Private Declare Function SHQueryRecycleBin Lib "shell32" _
                         Alias "SHQueryRecycleBinA" ( _
                         ByVal pszRootPath As String, _
                         ByRef pSHQueryRBInfo As SHQUERYRBINFO) As Long

Private Declare Function SHEmptyRecycleBin Lib "shell32" _
                         Alias "SHEmptyRecycleBinA" ( _
                         ByVal hWnd As Long, _
                         ByVal pszRootPath As String, _
                         ByVal dwFlags As EmptyFlags) As Long

Private Declare Function SHGetDesktopFolder Lib "shell32" ( _
                         ByRef ppshf As Long) As Long

Private Declare Function SHGetFolderLocation Lib "shell32" ( _
                         ByVal hwndOwner As Long, _
                         ByVal nFolder As Long, _
                         ByVal hToken As Long, _
                         ByVal dwReserved As Long, _
                         ByRef pidl As Long) As Long

Private Declare Function SHCreateShellItem Lib "shell32" ( _
                         ByVal pidlParent As Long, _
                         ByVal psfParent As Long, _
                         ByVal pidl As Long, _
                         ByRef ppsi As Long) As Long

Private Declare Function SHGetKnownFolderItem Lib "shell32" ( _
                         ByVal rfid As Long, _
                         ByVal dwFlags As Long, _
                         ByVal hToken As Long, _
                         ByVal riid As Long, _
                         ByRef ppv As Long) As Long

' **************** Ole32.dll ****************
Private Declare Function IIDFromString Lib "ole32" ( _
                         ByVal lpsz As Long, _
                         ByVal lpiid As Long) As Long

Private Declare Sub CoTaskMemFree Lib "ole32" ( _
                    ByVal pv As Long)

' **************** Oleaut32.dll ****************
Private Declare Function SysAllocString Lib "OleAut32" ( _
                         ByVal psz As Long) As String

' **************** Shlwapi.dll ****************
Private Declare Function StrRetToStrA Lib "shlwapi" ( _
                         ByVal pstr As Long, _
                         ByVal pidl As Long, _
                         ByRef ppszName As Long) As Long

' **************** User32.dll ****************
Private Declare Function CreatePopupMenu Lib "user32" () As Long

Private Declare Function DestroyMenu Lib "user32.dll" ( _
                         ByVal hMenu As Long) As Long
                         
' **************** Variablen ****************
Private m_RecycleBin() As RecycleBin

Public Function FindDelItem(ByVal sDelFileName As String) As String
    
    Dim sRet As String
    Dim sDelPath As String
    Dim pIEnumShellItems As Long
    Dim pIContextMenu As Long
    Dim pIShellItem_1 As Long
    Dim pIShellItem_2 As Long
    Dim ppIShellItem_2 As Long
    
    If SHGetKnownFolderItem(IIDtoLong(FOLDERID_RecycleBinFolder), KF_FLAG_DEFAULT, 0&, _
        IIDtoLong(IID_IShellItem), pIShellItem_1) = S_OK Then
        
        Dim IShellItem_1 As New clsIShellItem
        Call IShellItem_1.Initialize(pIShellItem_1)
        
        pIEnumShellItems = IShellItem_1.BindToHandler(0&, IIDtoLong(BHID_EnumItems), _
            IIDtoLong(IID_IEnumShellItems))
            
        If pIEnumShellItems <> 0 Then
        
            Dim IEnumShellItems As New clsIEnumShellItems
            Call IEnumShellItems.Initialize(pIEnumShellItems)
            Call IEnumShellItems.RaiseError(False)
            
            ppIShellItem_2 = VarPtr(pIShellItem_2)
            
            Do While IEnumShellItems.Fetch(1&, ppIShellItem_2, 0&) = True
            
                If pIShellItem_2 <> 0 Then
                    
                    Dim IShellItem_2 As New clsIShellItem
                    Call IShellItem_2.Initialize(pIShellItem_2)
                    
                    'Debug.Print IShellItem_2.GetDisplayName(SIGDN_NORMALDISPLAY)
                    'Debug.Print IShellItem_2.GetDisplayName(SIGDN_FILESYSPATH)
                    
                    sDelPath = IShellItem_2.GetDisplayName(SIGDN_FILESYSPATH)
                    
                    If InStr(1, sDelPath, sDelFileName) Then
                    
                        sRet = sDelPath
                        
                    End If
                    
                    Set IShellItem_2 = Nothing
                    
                End If
                
                Call CoTaskMemFree(pIShellItem_2)
                
            Loop
            
            Set IEnumShellItems = Nothing
            
        End If
        
        Set IShellItem_1 = Nothing
        
    End If
    
    FindDelItem = sRet
    
End Function

Public Sub FillLvListItems(ByVal LV As ListView)

    Dim lPIDL As Long
    Dim plPIDL As Long
    Dim lItem As Long
    Dim pIShellItem As Long
    Dim pIEnumIDList As Long
    Dim pIShellFolder As Long
    Dim pIContextMenu As Long
    Dim tSHELLDETAILS As SHELLDETAILS
    Dim ptSHELLDETAILS As Long
    Dim ptSHELLDETAILS_str As Long
    Dim pszName As Long
    Dim szName As String
    Dim sDelName As String
    Dim xListItem As ListItem

    LV.ListItems.Clear

    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)

        ' PIDL vom Papierkorb ermitteln
        If SHGetFolderLocation(0&, CSIDL_BITBUCKET, 0&, 0&, lPIDL) = S_OK Then

            pIShellFolder = IShellFolder.BindToObject(lPIDL, 0&, IIDtoLong(IID_IShellFolder2))

            If pIShellFolder <> 0 Then

                ' IShellFolder2 initialisieren
                Dim IShellFolder2 As New clsIShellFolder2
                Call IShellFolder2.Initialize(pIShellFolder)

                pIEnumIDList = IShellFolder2.EnumObjects(0&, SHCONTF_FOLDERS Or _
                    SHCONTF_NONFOLDERS Or SHCONTF_INCLUDEHIDDEN)

                If pIEnumIDList <> 0 Then

                    Dim IEnumIDList As New clsIEnumIDList
                    Call IEnumIDList.Initialize(pIEnumIDList)
                    Call IEnumIDList.RaiseError(False)

                    plPIDL = VarPtr(lPIDL)

                    Do While IEnumIDList.Fetch(1&, plPIDL, 0&) = True

                        ptSHELLDETAILS = VarPtr(tSHELLDETAILS)

                        ' die ersten 6 Eigenschaften auslesen
                        For lItem = 0 To 5

                            If IShellFolder2.GetDetailsOf(lPIDL, lItem, _
                                ptSHELLDETAILS) = True Then

                                ptSHELLDETAILS_str = VarPtr(tSHELLDETAILS.str)

                                ' Stringpointer von PIDL zu Stringpointer
                                If StrRetToStrA(ptSHELLDETAILS_str, 0&, pszName) = _
                                    S_OK Then

                                    ' Stringpointer zu String
                                    szName = CutNull(SysAllocString(pszName))
                                    szName = Replace$(szName, Chr$(63), vbNullString)
                                        
                                    If lItem = 0 Then
                                    
                                        If SHCreateShellItem(0&, 0&, lPIDL, pIShellItem) = S_OK Then
                                        
                                            Dim IShellItem As New clsIShellItem
                                            Call IShellItem.Initialize(pIShellItem)
                                        
                                            sDelName = IShellItem.GetDisplayName(SIGDN_NORMALDISPLAY)
                                        
                                            Set IShellItem = Nothing
                                        
                                        End If

                                        Set xListItem = LV.ListItems.Add(, sDelName, szName)
                                        
                                        xListItem.SubItems(6) = sDelName
                                    
                                    Else

                                        If lItem = 3 Then
                                        
                                            xListItem.SubItems(lItem) = FileSizeInKB(szName)
                                        
                                        Else
                                        
                                            xListItem.SubItems(lItem) = szName
                                        
                                        End If

                                    End If

                                    ' aufrumen
                                    Call CoTaskMemFree(pszName)

                                End If
                            End If

                        Next

                    Loop

                    Call IEnumIDList.RaiseError(True)

                    Set IEnumIDList = Nothing

                End If

                Set IShellFolder2 = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        Set IShellFolder = Nothing

    End If

End Sub

Public Sub FillLvColumnHeaders(ByVal LV As ListView)

    Dim lPIDL As Long
    Dim lItem As Long
    Dim pIShellFolder As Long
    Dim pIContextMenu As Long
    Dim tSHELLDETAILS As SHELLDETAILS
    Dim ptSHELLDETAILS As Long
    Dim ptSHELLDETAILS_str As Long
    Dim pszName As Long
    Dim szName As String
    Dim LvAlignment As ListColumnAlignmentConstants
    
    LV.ColumnHeaders.Clear
    
    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then
    
        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)
        
        ' PIDL vom Papierkorb ermitteln
        If SHGetFolderLocation(0&, CSIDL_BITBUCKET, 0&, 0&, lPIDL) = S_OK Then
        
            pIShellFolder = IShellFolder.BindToObject(lPIDL, 0&, IIDtoLong(IID_IShellFolder2))
            
            If pIShellFolder <> 0 Then
            
                ' IShellFolder2 initialisieren
                Dim IShellFolder2 As New clsIShellFolder2
                Call IShellFolder2.Initialize(pIShellFolder)
                
                ptSHELLDETAILS = VarPtr(tSHELLDETAILS)
                
                ' die ersten 6 Eigenschaften auslesen
                For lItem = 0 To 5
                
                    If IShellFolder2.GetDetailsOf(0&, lItem, ptSHELLDETAILS) = _
                        True Then
                        
                        ptSHELLDETAILS_str = VarPtr(tSHELLDETAILS.str)
                        
                        ' Stringpointer von PIDL zu Stringpointer
                        If StrRetToStrA(ptSHELLDETAILS_str, 0&, pszName) = S_OK Then
                            
                            ' Stringpointer zu String
                            szName = CutNull(SysAllocString(pszName))
                            szName = Replace$(szName, Chr$(63), vbNullString)
                            
                            If lItem = 3 Then
                                LvAlignment = lvwColumnRight
                            Else
                                LvAlignment = lvwColumnLeft
                            End If
                            
                            LV.ColumnHeaders.Add , , szName, 180, LvAlignment
                            
                            ' aufrumen
                            Call CoTaskMemFree(pszName)
                            
                        End If
                    End If
                    
                Next
                
                Set IShellFolder2 = Nothing
                
            End If
            
            ' aufrumen
            Call CoTaskMemFree(lPIDL)
            
        End If
        
        Set IShellFolder = Nothing
        
    End If
    
    LV.ColumnHeaders.Add , , "DeletedName", 180, LvAlignment
    
End Sub

Public Function WillRecycle(ByVal sPath As String) As Boolean

    Dim bRet As Boolean

    bRet = False

    If InStr(1, GetLocation(sPath), Left$(sPath, 3), vbTextCompare) Then
        If GetPurgeOnDelete(sPath) = False Then
            
            ' ToDo:
            ' Gre der Datei / Ordner ermitteln und prfen
            ' ob dieser noch in den Papierkorb passt.
            'If Datei/Ordnergre <= GetMaxCapacity(sPath) - GetUsedSpace(sPath) Then

                bRet = True

            'End If

        End If
    End If

    WillRecycle = bRet

End Function

Public Function GetRecycleBinName() As String

    Dim lPIDL As Long
    Dim sRet As String
    Dim pIShellItem As Long
    Dim pIShellFolder As Long
    
    ' IShellFolder des Desktop ermitteln
    If SHGetDesktopFolder(pIShellFolder) = S_OK Then

        ' IShellFolder initialisieren
        Dim IShellFolder As New clsIShellFolder
        Call IShellFolder.Initialize(pIShellFolder)

        ' PIDL vom Papierkorb ermitteln
        If SHGetFolderLocation(0&, CSIDL_BITBUCKET, 0&, 0&, lPIDL) = S_OK Then

            ' IShellItem von PIDL erstellen
            If SHCreateShellItem(0&, 0&, lPIDL, pIShellItem) = S_OK Then

                ' IShellItem initialisieren
                Dim IShellItem As New clsIShellItem
                Call IShellItem.Initialize(pIShellItem)

                ' Name vom Objekt ermitteln
                sRet = IShellItem.GetDisplayName(SIGDN_NORMALDISPLAY)

                Set IShellItem = Nothing

            End If

            ' aufrumen
            Call CoTaskMemFree(lPIDL)

        End If

        Set IShellFolder = Nothing

    End If

    GetRecycleBinName = sRet
    
End Function

' liet alle Papierkrbe neu ein
Public Function RefreshRecycleBins() As Boolean
    
    Dim sDrives() As String
    Dim sFolder As String
    Dim lCounter As Long
    Dim lItemReg As Long
    Dim lItemDrive As Long
    Dim lItemFolder As Long
    Dim lCountReg As Long
    Dim lCountDrive As Long
    Dim lCountFolder As Long
    Dim tFolder() As FolderList
    Dim tRegDWord() As RegDWord
    
    Erase m_RecycleBin
    
    ' alle verfgbaren Laufwerke ermitteln
    lCountDrive = GetAllDrives(sDrives)
    
    If lCountDrive > 0 Then
    
        ' alle Laufwerke durchlaufen
        For lItemDrive = 0 To lCountDrive - 1
        
            ' alle Ordner im Root des Laufwerkes ermitteln
            lCountFolder = ListFolder(sDrives(lItemDrive), tFolder)

            If lCountFolder > 1 Then
            
                ' alle Ordner im Root durchlaufen
                For lItemFolder = 1 To lCountFolder
                    
                    sFolder = tFolder(lItemFolder).FullPath
                    
                    ' ist im Root ein Ordner "$Recycle.Bin"
                    If InStr(1, sFolder, "$Recycle.Bin", vbTextCompare) Then
                        
                        If Right$(sFolder, 1) <> "\" Then sFolder = sFolder & "\"
                            
                        ' existiert ein Userordner im "$Recycle.Bin" Ordner
                        If DirExists(sFolder & GetCurrentUserSid) = True Then
                            
                            If lCounter = 0 Then
                                ReDim m_RecycleBin(lCounter)
                            Else
                                ReDim Preserve m_RecycleBin(lCounter)
                            End If
                        
                            m_RecycleBin(lCounter).sPath = sFolder & GetCurrentUserSid
                            m_RecycleBin(lCounter).sDrive = Left$(sFolder, 3)
                            m_RecycleBin(lCounter).sDriveGuid = GetVolumeGUID(m_RecycleBin(lCounter).sDrive)
                            m_RecycleBin(lCounter).sFolder = tFolder(lItemFolder).FullPath
                            m_RecycleBin(lCounter).sFolder = tFolder(lItemFolder).FolderName
                            
                            tRegDWord = GetVolumeRegRecycleBin(m_RecycleBin(lCounter).sDriveGuid)
                            lCountReg = UBound(tRegDWord)
                            
                            For lItemReg = 0 To lCountReg
                                
                                Select Case UCase(tRegDWord(lItemReg).Name)
                                Case "MAXCAPACITY"
                                    m_RecycleBin(lCounter).cMaxCapacity = tRegDWord(lItemReg).Value * 1024 * 1024
                                Case "NUKEONDELETE"
                                    m_RecycleBin(lCounter).bNukeOnDelete = CBool(tRegDWord(lItemReg).Value)
                                End Select
                            
                            Next
                        
                            
                            lCounter = lCounter + 1
                        
                            Exit For
                        
                        End If
                    End If
                Next
            End If
        Next
    End If
    
    RefreshRecycleBins = True
    
End Function

Public Function DeleteItem(ByVal sDelPath As String) As Long

    PurgeItem = InvokeVerb(sDelPath, Delete)

End Function

Public Function RestoreItem(ByVal sDelPath As String) As Long

    RestoreItem = InvokeVerb(sDelPath, Undelete)

End Function

Public Function ShowItemInfo(ByVal sDelPath As String) As Long

    ShowItemInfo = InvokeVerb(sDelPath, Properties)

End Function

' lscht den Inhalt aller oder eines bestimmten Papierkorbes
Public Function DeleteAllItems(Optional ByVal sPath As String = vbNullString, Optional _
    ByVal eFlags As EmptyFlags = SHERB_SILENT) As Boolean

    Dim bRet As Boolean

    bRet = False

    If sPath <> vbNullString Then

        If IsEmpty(sPath) = True Then

            bRet = True

        Else

            If SHEmptyRecycleBin(0&, sPath, eFlags) = S_OK Then

                bRet = True

            End If

        End If

    Else

        If SHEmptyRecycleBin(0&, sPath, eFlags) = S_OK Then

            bRet = True

        End If

    End If

    DeleteAllItems = bRet

End Function

' derzeit eingestellte Eigenschaft, ob die Dateien sofort gelscht
' werden sollen. (nicht in den Papierkorb verschieben)
Public Function GetPurgeOnDelete(ByVal sPath As String) As Boolean
    
    GetPurgeOnDelete = m_RecycleBin(GetIndex(sPath)).bNukeOnDelete
    
End Function

' derzeit eingestellte maximale Gre des Papierkorbes in Byte
Public Function GetMaxCapacity(ByVal sPath As String) As Currency
    
    GetMaxCapacity = m_RecycleBin(GetIndex(sPath)).cMaxCapacity
    
End Function

' Laufwerk auf dem der Papierkorb angelegt ist
Public Function GetLocation(ByVal sPath As String) As String
    
    GetLocation = m_RecycleBin(GetIndex(sPath)).sDrive
    
End Function

' Papierkorb anhand eines Pfades ermitteln
Public Function GetRecycleBin(ByVal sPath As String) As String

    GetRecycleBin = m_RecycleBin(GetIndex(sPath)).sPath

End Function

' sind die Papierkrbe / der Paierkorb leer
Public Function IsEmpty(Optional ByVal sPath As String = vbNullString) As Boolean

    Dim bRet As Boolean

    bRet = True

    If GetItemCount(sPath) > 0 Then

        bRet = False

    End If

    IsEmpty = bRet

End Function

' liefert die Anzahl der gelschten Elemente in allen Papierkrben
' oder eines bestimmten Papierkorbes
Public Function GetItemCount(Optional ByVal sPath As String = vbNullString) As Currency

    Dim tSHQUERYRBINFO As SHQUERYRBINFO
    
    tSHQUERYRBINFO.cbSize = Len(tSHQUERYRBINFO)
    
    Call SHQueryRecycleBin(sPath, tSHQUERYRBINFO)
    
    GetItemCount = tSHQUERYRBINFO.i64NumItems.LoHi * 10000

End Function

' liefert die Gre in Byte der gelschten Elemente in allen Papierkrben
' oder eines bestimmten Papierkorbes
Public Function GetUsedSpace(Optional ByVal sPath As String = vbNullString) As Currency

    Dim tSHQUERYRBINFO As SHQUERYRBINFO
    
    tSHQUERYRBINFO.cbSize = Len(tSHQUERYRBINFO)
    
    Call SHQueryRecycleBin(sPath, tSHQUERYRBINFO)
    
    GetUsedSpace = tSHQUERYRBINFO.i64Size.LoHi * 10000

End Function

' Papierkorb anhand eines Idexes ermitteln
Public Function GetRecycleBinAt(ByVal lIndex As Long) As String

    If lIndex < 0 Or lIndex > UBound(m_RecycleBin) Then Exit Function

    GetRecycleBinAt = m_RecycleBin(lIndex).sPath

End Function

' alle Papierkrbe ermitteln und Eigenschaften in m_RecycleBin ablegen
Public Function GetRecycleBinCount() As Long

    GetRecycleBinCount = UBound(m_RecycleBin) + 1
    
End Function

' ermittelt den Index vom Pfad eines Paierkorbes
Private Function GetIndex(ByVal sPath As String) As Long

    Dim lItem As Long
    Dim lCount As Long
    Dim lIndex As Long

    If Len(sPath) = 0 Then Exit Function

    sPath = Left$(sPath, 3)

    If InStr(1, sPath, ":\") Then

        lCount = UBound(m_RecycleBin)

        For lItem = 0 To lCount

            If InStr(1, m_RecycleBin(lItem).sDrive, sPath, vbTextCompare) Then

                lIndex = lItem

                Exit For

            End If

        Next

    End If

    GetIndex = lIndex
    
End Function

Private Function CutNull(ByVal sStr As String) As String
    
    Dim sRet As String
    
    If InStr(1, sStr, Chr$(0)) > 0 Then

        sRet = Mid$(sStr, 1, InStr(1, sStr, Chr$(0)) - 1)

    Else

        sRet = sStr

    End If

    CutNull = sRet
    
End Function

Private Function IIDtoLong(ByVal sIID As String) As Long

    Dim tIID(3) As Long
    Dim psIID As Long
    Dim ptIID As Long

    psIID = StrPtr(sIID)
    ptIID = VarPtr(tIID(0))
    
    Call IIDFromString(psIID, ptIID)
    
    IIDtoLong = ptIID
    
End Function

Private Function FileSizeInKB(ByVal sStr As String) As String

    Dim aStr() As String
    Dim sBytes As String
    Dim dBytes As Double
    Dim dRet As Double

    If sStr <> "" Then

        aStr() = Split(sStr, " ")
        sBytes = Replace$(aStr(0), ",", ".")

        Select Case UCase(aStr(1))

        Case "BYTES"
            dBytes = Val(sBytes)

        Case "KB"
            dBytes = Val(sBytes) * 1024

        Case "MB"
            dBytes = Val(sBytes) * (1024 ^ 2)

        Case "GB"
            dBytes = Val(sBytes) * (1024 ^ 3)

        End Select

        dRet = dBytes / 1024

        If dRet < 0.5 Then

            dRet = dRet + 1

        End If

        FileSizeInKB = Format$(dRet, "#,###,###,###") & " KB"

    End If

End Function

