Attribute VB_Name = "modShellExecuteEx"
Option Explicit

Private Const SEE_MASK_FLAG_NO_UI As Long = &H400
Private Const SEE_MASK_IDLIST As Long = &H4
Private Const SEE_MASK_INVOKEIDLIST As Long = &HC

Private Const SE_ERR_ACCESSDENIED As Long = 5
Private Const SE_ERR_ASSOCINCOMPLETE As Long = 27
Private Const SE_ERR_DDEBUSY As Long = 30
Private Const SE_ERR_DDEFAIL As Long = 29
Private Const SE_ERR_DDETIMEOUT As Long = 28
Private Const SE_ERR_DLLNOTFOUND As Long = 32
Private Const SE_ERR_FNF As Long = 2
Private Const SE_ERR_NOASSOC As Long = 31
Private Const SE_ERR_OOM As Long = 8
Private Const SE_ERR_PNF As Long = 3
Private Const SE_ERR_SHARE As Long = 26

Private Const HOTKEYF_ALT As Long = &H4
Private Const HOTKEYF_CONTROL As Long = &H2
Private Const HOTKEYF_EXT As Long = &H8
Private Const HOTKEYF_SHIFT As Long = &H1

Private Const INFINITE As Long = &HFFFF
Private Const WAIT_ABANDONED As Long = &H80
Private Const WAIT_FAILED As Long = &HFFFFFFFF
Private Const WAIT_OBJECT_0 As Long = &H0
Private Const WAIT_TIMEOUT As Long = &H102

Public Enum Verbs
    Undelete = 0
    Cut = 1
    Delete = 2
    Properties = 3
End Enum

Public Enum SW
    SW_HIDE = 0
    SW_SHOWNORMAL = 1
    SW_SHOWMINIMIZED = 2
    SW_MAXIMIZE = 3
    SW_SHOWMAXIMIZED = 3
    SW_SHOWNOACTIVATE = 4
    SW_SHOW = 5
    SW_MINIMIZE = 6
    SW_SHOWMINNOACTIVE = 7
    SW_SHOWNA = 8
    SW_RESTORE = 9
End Enum

Private Type SHELLEXECUTEINFO
    cbSize As Long
    fMask As Long
    hWnd As Long
    lpVerb As String
    lpFile As String
    lpParameters As String
    lpDirectory As String
    nShow As Long
    hInstApp As Long
    lpIDList As Long
    lpClass As String
    hkeyClass As Long
    dwHotKey As Long
    hIcon As Long
    hProcess As Long
End Type

Private Declare Function ShellExecuteEx Lib "shell32.dll" _
                         Alias "ShellExecuteExA" ( _
                         ByRef lpExecInfo As SHELLEXECUTEINFO) As Long

Private Declare Function WaitForSingleObject Lib "kernel32.dll" ( _
                         ByVal hHandle As Long, _
                         ByVal dwMilliseconds As Long) As Long

Public Function InvokeVerb(ByVal sDelPath As String, ByVal eVerbs As Verbs, _
    Optional eShow As SW = SW_SHOWNORMAL, Optional ByVal lHwnd As Long = 0&) As _
    Boolean

    Dim Retval As Long
    Dim sDelFolder As String
    Dim sDelFile As String
    Dim ShExInfo As SHELLEXECUTEINFO

    ' Pfad in Ordner und Datei aufteilen
    sDelFolder = Left$(sDelPath, InStrRev(sDelPath, "\") - 1)
    sDelFile = Right$(sDelPath, Len(sDelPath) - InStrRev(sDelPath, "\"))

    ' Startoptionen festlegen
    With ShExInfo

        .cbSize = Len(ShExInfo)
        .hWnd = lHwnd
        .lpFile = sDelFile
        .lpDirectory = sDelFolder

        Select Case eVerbs

        Case Verbs.Undelete
            .lpVerb = "undelete"

        Case Verbs.Cut
            .lpVerb = "cut"

        Case Verbs.Delete
            .lpVerb = "delete"

        Case Verbs.Properties
            .lpVerb = "properties"

        End Select

        .nShow = eShow

    End With

    ' Programm ausfhren
    Retval = ShellExecuteEx(ShExInfo)

    If Retval = 0 Then

        ' bei Fehler Text ausgeben
        Select Case ShExInfo.hInstApp

        Case SE_ERR_ACCESSDENIED
            Err.Raise 5, "ShellExecuteEx", "Zugriff verweigert"

        Case SE_ERR_FNF
            Err.Raise 5, "ShellExecuteEx", "Datei nicht gefunden"

        Case SE_ERR_NOASSOC
            Err.Raise 5, "ShellExecuteEx", "Datei ist mit keinem Programm verknpft"

        End Select

    End If

    Do

        DoEvents

    Loop Until WaitForSingleObject(ShExInfo.hProcess, 100&)

    InvokeVerb = True

End Function


