Attribute VB_Name = "modShellNotify"
Option Explicit

Private Const S_OK As Long = &H0
Private Const WM_DESTROY As Long = &H2
Private Const WM_SHNOTIFY As Long = &H488
Private Const SHCNEE_ORDERCHANGED As Long = &H2
Private Const MAX_PATH As Long = 260

Public Enum SHCN_EventIDs
    SHCNE_RENAMEITEM = &H1
    SHCNE_CREATE = &H2
    SHCNE_DELETE = &H4
    SHCNE_MKDIR = &H8
    SHCNE_RMDIR = &H10
    SHCNE_MEDIAINSERTED = &H20
    SHCNE_MEDIAREMOVED = &H40
    SHCNE_DRIVEREMOVED = &H80
    SHCNE_DRIVEADD = &H100
    SHCNE_NETSHARE = &H200
    SHCNE_NETUNSHARE = &H400
    SHCNE_ATTRIBUTES = &H800
    SHCNE_UPDATEDIR = &H1000
    SHCNE_UPDATEITEM = &H2000
    SHCNE_SERVERDISCONNECT = &H4000
    SHCNE_UPDATEIMAGE = &H8000&
    SHCNE_DRIVEADDGUI = &H10000
    SHCNE_RENAMEFOLDER = &H20000
    SHCNE_DISKEVENTS = &H2381F
    SHCNE_FREESPACE = &H40000
    SHCNE_EXTENDED_EVENT = &H4000000
    SHCNE_ASSOCCHANGED = &H8000000
    SHCNE_GLOBALEVENTS = &HC0581E0
    SHCNE_ALLEVENTS = &H7FFFFFFF
    SHCNE_INTERRUPT = &H80000000
End Enum

Public Enum SHCNRF
    SHCNRF_InterruptLevel = &H1
    SHCNRF_ShellLevel = &H2
    SHCNRF_RecursiveInterrupt = &H1000
    SHCNRF_NewDelivery = &H8000&
End Enum

Public Enum SHCN_ItemFlags
    SHCNF_IDLIST = &H0
    SHCNF_PATHA = &H1
    SHCNF_PRINTERA = &H2
    SHCNF_DWORD = &H3
    SHCNF_PATHW = &H5
    SHCNF_PRINTERW = &H6
    SHCNF_TYPE = &HFF
    SHCNF_FLUSH = &H1000
    SHCNF_FLUSHNOWAIT = &H2000
    SHCNF_PATH = SHCNF_PATHW
    SHCNF_PRINTER = SHCNF_PRINTERW
End Enum

Public Enum SHSpecialFolderIDs
    CSIDL_ADMINTOOLS = &H30
    CSIDL_ALTSTARTUP = &H1D
    CSIDL_APPDATA = &H1A
    CSIDL_BITBUCKET = &HA
    CSIDL_CDBURN_AREA = &H3B
    CSIDL_COMMON_ADMINTOOLS = &H2F
    CSIDL_COMMON_ALTSTARTUP = &H1E
    CSIDL_COMMON_APPDATA = &H23
    CSIDL_COMMON_DESKTOPDIRECTORY = &H19
    CSIDL_COMMON_DOCUMENTS = &H2E
    CSIDL_COMMON_FAVORITES = &H1F
    CSIDL_COMMON_MUSIC = &H35
    CSIDL_COMMON_OEM_LINKS = &H3A
    CSIDL_COMMON_PICTURES = &H36
    CSIDL_COMMON_PROGRAMS = &H17
    CSIDL_COMMON_STARTMENU = &H16
    CSIDL_COMMON_STARTUP = &H18
    CSIDL_COMMON_TEMPLATES = &H2D
    CSIDL_COMMON_VIDEO = &H37
    CSIDL_COMPUTERSNEARME = &H3D
    CSIDL_CONNECTIONS = &H31
    CSIDL_CONTROLS = &H3
    CSIDL_COOKIES = &H21
    CSIDL_DESKTOP = &H0
    CSIDL_DESKTOPDIRECTORY = &H10
    CSIDL_DRIVES = &H11
    CSIDL_FAVORITES = &H6
    CSIDL_FLAG_CREATE = &H8000
    CSIDL_FLAG_DONT_VERIFY = &H4000
    CSIDL_FLAG_MASK = &HFF00
    CSIDL_FLAG_NO_ALIAS = &H1000
    CSIDL_FLAG_PER_USER_INIT = &H800
    CSIDL_FONTS = &H14
    CSIDL_HISTORY = &H22
    CSIDL_INTERNET = &H1
    CSIDL_INTERNET_CACHE = &H20
    CSIDL_LOCAL_APPDATA = &H1C
    CSIDL_MYDOCUMENTS = &HC
    CSIDL_MYMUSIC = &HD
    CSIDL_MYPICTURES = &H27
    CSIDL_MYVIDEO = &HE
    CSIDL_NETHOOD = &H13
    CSIDL_NETWORK = &H12
    CSIDL_PERSONAL = &H5
    CSIDL_PRINTERS = &H4
    CSIDL_PRINTHOOD = &H1B
    CSIDL_PROFILE = &H28
    CSIDL_PROGRAM_FILES = &H26
    CSIDL_PROGRAM_FILES_COMMON = &H2B
    CSIDL_PROGRAM_FILES_COMMONX86 = &H2C
    CSIDL_PROGRAM_FILESX86 = &H2A
    CSIDL_PROGRAMS = &H2
    CSIDL_RECENT = &H8
    CSIDL_RESOURCES = &H38
    CSIDL_RESOURCES_LOCALIZED = &H39
    CSIDL_SENDTO = &H9
    CSIDL_STARTMENU = &HB
    CSIDL_STARTUP = &H7
    CSIDL_SYSTEM = &H25
    CSIDL_SYSTEMX86 = &H29
    CSIDL_TEMPLATES = &H15
    CSIDL_WINDOWS = &H24
End Enum

Private Type SHNOTIFYSTRUCT
    dwItem1 As Long
    dwItem2 As Long
End Type

Private Type SHChangeNotifyEntry
    pidl As Long
    fRecursive As Long
End Type

Private Declare Function SHChangeNotifyRegister Lib "shell32" ( _
                         ByVal hWnd As Long, _
                         ByVal fSources As SHCNRF, _
                         ByVal fEvents As SHCN_EventIDs, _
                         ByVal wMsg As Long, _
                         ByVal cEntries As Long, _
                         ByVal lpps As Long) As Long

Private Declare Function SHChangeNotifyDeregister Lib "shell32" ( _
                         ByVal hNotify As Long) As Boolean

Private Declare Function SHChangeNotification_Lock Lib "shell32" ( _
                         ByVal hChange As Long, _
                         ByVal dwProcId As Long, _
                         ByRef pppidl As Long, _
                         ByRef plEvent As Long) As Long

Private Declare Function SHChangeNotification_Unlock Lib "shell32" ( _
                         ByVal hLock As Long) As Long

Private Declare Function SHGetPathFromIDListW Lib "shell32.dll" ( _
                         ByVal pidl As Long, _
                         ByVal pszPath As Long) As Long

Private Declare Function SHGetFolderLocation Lib "shell32" ( _
                         ByVal hwndOwner As Long, _
                         ByVal nFolder As Long, _
                         ByVal hToken As Long, _
                         ByVal dwReserved As Long, _
                         ByRef pidl As Long) As Long

Private Declare Function ILCreateFromPathW Lib "shell32" ( _
                         ByVal pszPath As Long) As Long

Private Declare Function ILFree Lib "shell32" ( _
                         ByVal pidl As Long) As Long

Private Declare Function DefSubclassProc Lib "comctl32.dll" ( _
                         ByVal hWnd As Long, _
                         ByVal uMsg As Long, _
                         ByVal wParam As Long, _
                         ByVal lParam As Long) As Long

Private Declare Function SetWindowSubclass Lib "comctl32.dll" ( _
                         ByVal hWnd As Long, _
                         ByVal pfnSubclass As Long, _
                         ByVal uIdSubclass As Long, _
                         ByVal dwRefData As Long) As Long

Private Declare Function RemoveWindowSubclass Lib "comctl32.dll" ( _
                         ByVal hWnd As Long, _
                         ByVal pfnSubclass As Long, _
                         ByVal uIdSubclass As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef Destination As Any, _
                    ByRef Source As Any, _
                    ByVal Length As Long)

Private ltCNECount As Long
Private m_hSHNotify As Long

Public m_ShellNotifyClass As New Collection

Private tCNE() As SHChangeNotifyEntry

Public Function StartNotify(ByVal hWnd As Long, Optional ByVal lSHSpecialFolder As _
    SHSpecialFolderIDs = CSIDL_DESKTOP, Optional ByRef sPaths As Variant, Optional _
    ByVal lEvents As SHCN_EventIDs = SHCNE_ALLEVENTS Or SHCNE_INTERRUPT, Optional _
    ByVal bRecursive As Boolean = True) As Boolean

    Dim bRet As Boolean
    Dim lItem As Long
    Dim lPIDL As Long
    Dim psPaths As Long
    Dim sPath As String

    bRet = False

    If (m_hSHNotify = 0) Then

        If IsMissing(sPaths) Then

            If SHGetFolderLocation(0&, lSHSpecialFolder, 0&, 0&, lPIDL) = S_OK Then

                ltCNECount = 1
                ReDim tCNE(0)

                tCNE(0).pidl = lPIDL
                tCNE(0).fRecursive = CLng(bRecursive)

            Else

                Exit Function

            End If

        Else

            ltCNECount = UBound(sPaths) + 1
            ReDim tCNE(ltCNECount - 1)

            For lItem = 0 To ltCNECount - 1

                sPath = sPaths(lItem)

                psPaths = StrPtr(sPath)

                lPIDL = ILCreateFromPathW(psPaths)

                If lPIDL <> 0 Then

                    tCNE(lItem).pidl = lPIDL
                    tCNE(lItem).fRecursive = CLng(bRecursive)

                Else

                    Exit Function

                End If

            Next

        End If

        m_hSHNotify = SHChangeNotifyRegister(hWnd, SHCNRF_ShellLevel Or _
            SHCNRF_InterruptLevel Or SHCNRF_NewDelivery, lEvents, WM_SHNOTIFY, _
            ltCNECount, VarPtr(tCNE(0)))

        If m_hSHNotify <> 0 Then

            bRet = True

        End If

    End If

    StartNotify = bRet

End Function

Public Function StopNotify() As Boolean

    Dim lItem As Long

    StopNotify = SHChangeNotifyDeregister(m_hSHNotify)

    For lItem = 0 To ltCNECount - 1

        Call ILFree(tCNE(lItem).pidl)

    Next

End Function

Public Function LookUpSHCNE(ByVal uMsg As Long) As String

    Select Case uMsg

    Case &H1: LookUpSHCNE = "SHCNE_RENAMEITEM"
    Case &H2: LookUpSHCNE = "SHCNE_CREATE"
    Case &H4: LookUpSHCNE = "SHCNE_DELETE"
    Case &H8: LookUpSHCNE = "SHCNE_MKDIR"
    Case &H10: LookUpSHCNE = "SHCNE_RMDIR"
    Case &H20: LookUpSHCNE = "SHCNE_MEDIAINSERTED"
    Case &H40: LookUpSHCNE = "SHCNE_MEDIAREMOVED"
    Case &H80: LookUpSHCNE = "SHCNE_DRIVEREMOVED"
    Case &H100: LookUpSHCNE = "SHCNE_DRIVEADD"
    Case &H200: LookUpSHCNE = "SHCNE_NETSHARE"
    Case &H400: LookUpSHCNE = "SHCNE_NETUNSHARE"
    Case &H800: LookUpSHCNE = "SHCNE_ATTRIBUTES"
    Case &H1000: LookUpSHCNE = "SHCNE_UPDATEDIR"
    Case &H2000: LookUpSHCNE = "SHCNE_UPDATEITEM"
    Case &H4000: LookUpSHCNE = "SHCNE_SERVERDISCONNECT"
    Case &H8000&: LookUpSHCNE = "SHCNE_UPDATEIMAGE"
    Case &H10000: LookUpSHCNE = "SHCNE_DRIVEADDGUI"
    Case &H20000: LookUpSHCNE = "SHCNE_RENAMEFOLDER"
    Case &H2381F: LookUpSHCNE = "SHCNE_DISKEVENTS"
    Case &H40000: LookUpSHCNE = "SHCNE_FREESPACE"
    Case &H4000000: LookUpSHCNE = "SHCNE_EXTENDED_EVENT"
    Case &H8000000: LookUpSHCNE = "SHCNE_ASSOCCHANGED"
    Case &HC0581E0: LookUpSHCNE = "SHCNE_GLOBALEVENTS"
    Case &H7FFFFFFF: LookUpSHCNE = "SHCNE_ALLEVENTS"
    Case &H80000000: LookUpSHCNE = "SHCNE_INTERRUPT"

    End Select

End Function

Public Function GetPathFromPIDLW(ByVal pidl As Long) As String

    Dim pszPath As String

    pszPath = String(MAX_PATH, 0)

    If SHGetPathFromIDListW(pidl, StrPtr(pszPath)) Then
        If InStr(pszPath, vbNullChar) Then

            GetPathFromPIDLW = Left$(pszPath, InStr(pszPath, vbNullChar) - 1)

        End If
    End If

End Function

Public Function Subclass(ByVal hWnd As Long, ByVal lpfn As Long, Optional ByVal _
    uId As Long = 0&, Optional ByVal dwRefData As Long = 0&) As Boolean

    If uId = 0 Then uId = hWnd

    Subclass = SetWindowSubclass(hWnd, lpfn, uId, dwRefData)

End Function

Public Function UnSubclass(ByVal hWnd As Long, ByVal lpfn As Long, ByVal pid As _
    Long) As Boolean

    UnSubclass = RemoveWindowSubclass(hWnd, lpfn, pid)

End Function

Public Function FARPROC(ByVal pfn As Long) As Long

    FARPROC = pfn

End Function

Public Function WndProc(ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As _
    Long, ByVal lParam As Long, ByVal uIdSubclass As Long, ByVal dwRefData As _
    Long) As Long

    Dim NotifyClass As clsShellNotify

    Select Case uMsg

    Case WM_SHNOTIFY

        Dim lEvent As Long
        Dim pInfo As Long
        Dim tInfo As SHNOTIFYSTRUCT
        Dim hNotifyLock As Long

        hNotifyLock = SHChangeNotification_Lock(wParam, lParam, pInfo, lEvent)

        If hNotifyLock Then

            CopyMemory tInfo, ByVal pInfo, LenB(tInfo)

            For Each NotifyClass In m_ShellNotifyClass

                Call NotifyClass.RaiseShellEvent(tInfo.dwItem1, tInfo.dwItem2, _
                    lEvent)

            Next NotifyClass

            Call SHChangeNotification_Unlock(hNotifyLock)

        End If

    Case WM_DESTROY

        Call UnSubclass(hWnd, PtrWndProc, uIdSubclass)

    End Select

    WndProc = DefSubclassProc(hWnd, uMsg, wParam, lParam)

    Exit Function

End Function

Private Function PtrWndProc() As Long

    PtrWndProc = FARPROC(AddressOf WndProc)

End Function

