Attribute VB_Name = "modUserID"
' Autor: F. Schler (frank@activevb.de)
' Datum: 11/2017

Option Explicit

' **************** Const ****************
Private Const TOKEN_READ As Long = &H20008
Private Const TOKEN_INFORMATION_CLASS_TokenUser As Long = &H1

' **************** Kernel32.dll ****************
Private Declare Sub CopyMemory Lib "kernel32" _
                    Alias "RtlMoveMemory" ( _
                    ByRef pTo As Any, _
                    ByRef uFrom As Any, _
                    ByVal lSize As Long)

Private Declare Function GetCurrentProcess Lib "kernel32" () As Long

Private Declare Function CloseHandle Lib "kernel32" ( _
                         ByVal hObject As Long) As Long

Private Declare Function LocalFree Lib "kernel32" ( _
                         ByVal hMem As Long) As Long

Private Declare Function lstrlen Lib "kernel32" _
                         Alias "lstrlenA" ( _
                         ByVal lpString As Long) As Long

' **************** Advapi32.dll ****************
Private Declare Function OpenProcessToken Lib "advapi32" ( _
                         ByVal ProcessHandle As Long, _
                         ByVal DesiredAccess As Long, _
                         ByRef TokenHandle As Long) As Long

Private Declare Function GetTokenInformation Lib "advapi32" ( _
                         ByVal TokenHandle As Long, _
                         ByVal TokenInformationClass As Long, _
                         ByRef TokenInformation As Any, _
                         ByVal TokenInformationLength As Long, _
                         ReturnLength As Long) As Long

Private Declare Function ConvertSidToStringSid Lib "advapi32" _
                         Alias "ConvertSidToStringSidA" ( _
                         ByVal lpSid As Long, _
                         ByRef lpString As Long) As Long

' ermittelt die UserID vom angemeldeten Benutzer
Public Function GetCurrentUserSid() As String

    Dim lpSid As Long
    Dim hToken As Long
    Dim lNeeded As Long
    Dim lpString As Long
    Dim hProcessID As Long
    Dim baBuffer() As Byte
    Dim sBuffer As String

    hProcessID = GetCurrentProcess()

    If hProcessID <> 0 Then

        If OpenProcessToken(hProcessID, TOKEN_READ, hToken) = 1 Then

            Call GetTokenInformation(hToken, TOKEN_INFORMATION_CLASS_TokenUser, _
                ByVal 0, 0, lNeeded)

            ReDim baBuffer(0 To lNeeded)

            If GetTokenInformation(hToken, TOKEN_INFORMATION_CLASS_TokenUser, _
                baBuffer(0), UBound(baBuffer), lNeeded) = 1 Then

                Call CopyMemory(lpSid, baBuffer(0), 4)

                If ConvertSidToStringSid(lpSid, lpString) Then

                    sBuffer = Space(lstrlen(lpString))

                    Call CopyMemory(ByVal sBuffer, ByVal lpString, Len(sBuffer))

                    Call LocalFree(lpString)

                    GetCurrentUserSid = sBuffer

                End If
            End If

            Call CloseHandle(hToken)

        End If

        Call CloseHandle(hProcessID)

    End If

End Function


